/* eslint no-sync:0 */

// Import
'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

exports['default'] = lazyRequire;
var pathUtil = require('path');
var fsUtil = require('fs');
var safeps = require('safeps');
var extractOptsAndCallback = require('extract-opts');

// Prepare
function complete(error, result, next) {
	if (next) {
		next(error, result);
		return null;
	} else {
		return error || result;
	}
}

// =====================================
// Define Module

// Require or install a package synchronously or asynchronously
// Also export this function as the default

function lazyRequire(name, opts, next) {

	// If we have a callback, then do async

	var _extractOptsAndCallback = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback2 = _slicedToArray(_extractOptsAndCallback, 2);

	opts = _extractOptsAndCallback2[0];
	next = _extractOptsAndCallback2[1];
	return next ? lazyRequire.async(name, opts, next) : lazyRequire.sync(name, opts);
}

// Require or install a package synchronously or asynchronously
lazyRequire.auto = function (name, opts, next) {

	// If we have no callback, or if we support sync, then do sync

	var _extractOptsAndCallback3 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback32 = _slicedToArray(_extractOptsAndCallback3, 2);

	opts = _extractOptsAndCallback32[0];
	next = _extractOptsAndCallback32[1];
	if (!next || lazyRequire.canSyncInstall()) {
		return lazyRequire.requireOrInstallSync(name, opts, next);
	} else {
		return lazyRequire.requireOrInstallAsync(name, opts, next);
	}
};

// Require or install a package synchronously
lazyRequire.sync = function (name, opts, next) {
	var _extractOptsAndCallback4 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback42 = _slicedToArray(_extractOptsAndCallback4, 2);

	opts = _extractOptsAndCallback42[0];
	next = _extractOptsAndCallback42[1];

	var result = lazyRequire.require(name, opts);
	var error = null;

	// Synchronous
	if (result instanceof Error) {
		result = lazyRequire.installSync(name, opts);
		if (result instanceof Error) {
			error = result;
			result = null;
		}
	}

	// Complete
	return complete(error, result, next);
};

// Require or install a package asynchronously
lazyRequire.async = function (name, opts, next) {

	// Asynchronous

	var _extractOptsAndCallback5 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback52 = _slicedToArray(_extractOptsAndCallback5, 2);

	opts = _extractOptsAndCallback52[0];
	next = _extractOptsAndCallback52[1];
	lazyRequire.require(name, opts, function (error, result) {
		if (result) return next(error, result);
		lazyRequire.installAsync(name, opts, next);
	});

	// Exit
	return null;
};

// Attempt to require a module
lazyRequire.require = function (name, opts, next) {
	var _extractOptsAndCallback6 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback62 = _slicedToArray(_extractOptsAndCallback6, 2);

	opts = _extractOptsAndCallback62[0];
	next = _extractOptsAndCallback62[1];

	var result = null;
	var error = null;

	// Fetch
	try {
		result = require(name);
	} catch (e1) {
		error = e1;

		if (opts.cwd) {
			var path = pathUtil.join(opts.cwd, 'node_modules', name);
			try {
				result = require(path);
				error = null;
			} catch (e2) {
				error = e2;
			}
		}
	}

	// Complete
	return complete(error, result, next);
};

// Can Save
lazyRequire.canSave = function (name, opts, next) {
	var _extractOptsAndCallback7 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback72 = _slicedToArray(_extractOptsAndCallback7, 2);

	opts = _extractOptsAndCallback72[0];
	next = _extractOptsAndCallback72[1];

	var result = null;
	var error = null;

	// Options
	if (opts.cwd == null) {
		opts.cwd = process.cwd();
	}
	opts.packagePath = pathUtil.join(opts.cwd, 'package.json');

	// Fetch
	try {
		result = fsUtil.existsSync(opts.packagePath) === true;
	} catch (err) {
		error = err;
	}

	// Complete
	return complete(error, result, next);
};

// Can install synchronously
lazyRequire.canSyncInstall = function (opts, next) {
	var _extractOptsAndCallback8 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback82 = _slicedToArray(_extractOptsAndCallback8, 2);

	opts = _extractOptsAndCallback82[0];
	next = _extractOptsAndCallback82[1];

	var result = safeps.hasSpawnSync();
	var error = null;

	// Fetch
	if (result instanceof Error) {
		error = result;
		result = null;
	}

	// Complete
	return complete(error, result, next);
};

// Attempt to require a module (will install if missing)
// Asynchronous with optional callback
lazyRequire.installAsync = function (name, opts, next) {
	var _extractOptsAndCallback9 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback92 = _slicedToArray(_extractOptsAndCallback9, 2);

	opts = _extractOptsAndCallback92[0];
	next = _extractOptsAndCallback92[1];

	var error = null;

	// Defaults
	if (opts.save == null) {
		opts.save = false;
	}
	if (opts.cwd == null) {
		opts.cwd = process.cwd();
	}

	// Check that we are not in the browser
	if (process.browser === true) {
		error = new Error('lazy-require: installing in the browser is not possible');
	}

	// Check saving
	else if (opts.save === true && lazyRequire.canSave() === false) {
			error = new Error('lazy-require: cannot save the module as `opts.cwd` did not contain a `package.json` file');
		}

		// Install
		else {
				// Arguments
				var args = ['npm', 'install', name];
				if (opts.save === true) {
					args.push('--save');
					opts.save = null; // {delete opts.save} is very slow
				}

				// Install
				safeps.spawn(args, opts, function (err) {
					// Check
					if (err) return next(err);

					// Try to load the module
					lazyRequire.require(name, opts, next);
				});

				// Exit
				return null;
			}

	// Complete
	return complete(error, null, next);
};

// Attempt to require a module (will install if missing)
// Synchronous with optional callback
lazyRequire.installSync = function (name, opts, next) {
	var _extractOptsAndCallback10 = extractOptsAndCallback(opts, next);

	// Prepare

	var _extractOptsAndCallback102 = _slicedToArray(_extractOptsAndCallback10, 2);

	opts = _extractOptsAndCallback102[0];
	next = _extractOptsAndCallback102[1];

	var error = null;

	// Defaults
	if (opts.save == null) {
		opts.save = false;
	}
	if (opts.cwd == null) {
		opts.cwd = process.cwd();
	}

	// Check that we are not in the browser
	if (process.browser === true) {
		error = new Error('lazy-require: installing in the browser is not possible');
	}

	// Check that spawnSync exists, check that the project's package.json exists
	else if (lazyRequire.canSyncInstall() === false) {
			error = new Error('lazy-require: installing synchronously is not possible');
		}

		// Check saving
		else if (opts.save === true && lazyRequire.canSave() === false) {
				error = new Error('lazy-require: cannot save the module as `opts.cwd` did not contain a `package.json` file');
			}

			// Install
			else {
					// Arguments
					var args = ['npm', 'install', name];
					if (opts.save === true) {
						args.push('--save');
						opts.save = null; // {delete opts.save} is very slow
					}

					// Install
					var spawnResult = safeps.spawnSync(args, opts);
					if (spawnResult instanceof Error) {
						error = spawnResult;
					} else {
						// Exit
						return lazyRequire.require(name, opts, next);
					}
				}

	// Complete
	return complete(error, null, next);
};
module.exports = exports['default'];